Index: manager.c
===================================================================
RCS file: /usr/cvsroot/asterisk/manager.c,v
retrieving revision 1.110
diff -u -r1.110 manager.c
--- manager.c	26 Aug 2005 23:04:20 -0000	1.110
+++ manager.c	11 Oct 2005 20:07:54 -0000
@@ -655,9 +655,9 @@
 }
 
 static char mandescr_getvar[] = 
-"Description: Get the value of a local channel variable.\n"
+"Description: Get the value of a global or local channel variable.\n"
 "Variables: (Names marked with * are required)\n"
-"	*Channel: Channel to read variable from\n"
+"	Channel: Channel to read variable from, if channel var\n"
 "	*Variable: Variable name\n"
 "	ActionID: Optional Action id for message matching.\n";
 
@@ -670,19 +670,17 @@
 	char *varval;
 	char *varval2=NULL;
 
-	if (!strlen(name)) {
-		astman_send_error(s, m, "No channel specified");
-		return 0;
-	}
 	if (!strlen(varname)) {
 		astman_send_error(s, m, "No variable specified");
 		return 0;
 	}
 
-	c = ast_get_channel_by_name_locked(name);
-	if (!c) {
-		astman_send_error(s, m, "No such channel");
-		return 0;
+	if (strlen(name)) {
+		c = ast_get_channel_by_name_locked(name);
+		if (!c) {
+			astman_send_error(s, m, "No such channel");
+			return 0;
+		}
 	}
 	
 	varval=pbx_builtin_getvar_helper(c,varname);
@@ -690,8 +688,10 @@
 		varval2 = ast_strdupa(varval);
 	if (!varval2)
 		varval2 = "";
-	ast_mutex_unlock(&c->lock);
-	ast_mutex_lock(&s->lock);
+	if (c) {
+		ast_mutex_unlock(&c->lock);
+		ast_mutex_lock(&s->lock);
+	}
 	ast_cli(s->fd, "Response: Success\r\n"
 		"%s: %s\r\n" ,varname,varval2);
 	if (id && !ast_strlen_zero(id))
